/**
 * {一些常量}
 * @author yutent<yutent.io@gmail.com>
 * @date 2024/03/06 16:25:01
 */

export const doc = document
export const win = window
export const xlink = 'http://www.w3.org/1999/xlink'
export const xmlns = 'http://www.w3.org/2000/svg'

export const CSS_ATTR = {
  'alignment-baseline': 1,
  'baseline-shift': 1,
  clip: 1,
  'clip-path': 1,
  'clip-rule': 1,
  color: 1,
  'color-interpolation': 1,
  'color-interpolation-filters': 1,
  'color-profile': 1,
  'color-rendering': 1,
  cursor: 1,
  direction: 1,
  display: 1,
  'dominant-baseline': 1,
  'enable-background': 1,
  fill: 1,
  'fill-opacity': 1,
  'fill-rule': 1,
  filter: 1,
  'flood-color': 1,
  'flood-opacity': 1,
  font: 1,
  'font-family': 1,
  'font-size': 1,
  'font-size-adjust': 1,
  'font-stretch': 1,
  'font-style': 1,
  'font-variant': 1,
  'font-weight': 1,
  'glyph-orientation-horizontal': 1,
  'glyph-orientation-vertical': 1,
  'image-rendering': 1,
  kerning: 1,
  'letter-spacing': 1,
  'lighting-color': 1,
  marker: 1,
  'marker-end': 1,
  'marker-mid': 1,
  'marker-start': 1,
  mask: 1,
  opacity: 1,
  overflow: 1,
  'pointer-events': 1,
  'shape-rendering': 1,
  'stop-color': 1,
  'stop-opacity': 1,
  stroke: 1,
  'stroke-dasharray': 1,
  'stroke-dashoffset': 1,
  'stroke-linecap': 1,
  'stroke-linejoin': 1,
  'stroke-miterlimit': 1,
  'stroke-opacity': 1,
  'stroke-width': 1,
  'text-anchor': 1,
  'text-decoration': 1,
  'text-rendering': 1,
  'unicode-bidi': 1,
  visibility: 1,
  'word-spacing': 1,
  'writing-mode': 1
}

export const ISURL = /^url\(['"]?([^\)]+?)['"]?\)$/i

export const SEPARATOR = /[,\s]+/
export const whitespace = /[\s]/g
export const commaSpaces = /[\s]*,[\s]*/
export const bezierrg = /^(?:cubic-)?bezier\(([^,]+),([^,]+),([^,]+),([^\)]+)\)/
export const pathCommand =
  /([a-z])[\s,]*((-?\d*\.?\d*(?:e[\-+]?\d+)?[\s]*,?[\s]*)+)/gi
export const T_COMMAND =
  /([rstm])[\s,]*((-?\d*\.?\d*(?:e[\-+]?\d+)?[\s]*,?[\s]*)+)/gi
export const PATH_VALUES = /(-?\d*\.?\d*(?:e[\-+]?\d+)?)[\s]*,?[\s]*/gi
